<?php
/*
Plugin Name: DateChanger
Plugin URI: http://www.nowhereland.it/
Type: Block
Description: Let you change date for entries and clutters the interface with another drop down menu
Author: NoWhereMan
Version: 1.0
Author URI: http://www.nowhereland.it/
*/ 
 
if (! (
	basename($_SERVER['PHP_SELF']) == 'admin.php'	&&	// must be admin area
	@$_GET['p'] == 'entry' 				&&	// must be right panel
	@$_GET['action'] == 'write'			&&	// must be right action
	!(@$_POST['timestamp'] || @$_REQUEST['entry'])	// must be a new entry
	) ) 
		return;
 
function plugin_datechanger_toolbar() {
	
	$lang = lang_load('plugin:datechanger');
	$time = time();
 
	$h = date('H', $time);
	$m = date('i', $time);
	$s = date('s', $time);
 
	$Y = date('Y', $time);
	$M = date('m', $time);
	$D = date('d', $time);
	
	echo '<link rel="stylesheet" type="text/css" href="'.plugin_geturl('datechanger') . 'res/calendar.css" />', "\n";
	echo '<script type="text/javascript" src="'.plugin_geturl('datechanger') . 'res/calendar.js"></script>', "\n";
	
	echo '<form>';
	echo '<span id="admin-date"><br>';
	
	echo $lang['plugin']['datechanger']['date'];
	echo '<input type="text" value="'.$Y.'/'.$M.'/'.$D.'" size="10" readonly name="pubDate" onclick="displayCalendar(document.forms[0].pubDate,\'yyyy/mm/dd\',this)"><br>';
	
	echo $lang['plugin']['datechanger']['time'];
	echo '<input id="pubTime" type="text" value="'.$h.':'.$m.':'.$s.'" size="7" name="pubTime">';
	echo '</input>';
	echo '</span>';
	echo '</form>';
 
}
 
add_action('editor_toolbar', 'plugin_datechanger_toolbar');
 
 
function plugin_datechanger_check() {
 
	if ((isset($_GET['p']) && $_GET['p'] != 'entry') || 
		(isset($_GET['action']) &&  $_GET['action'] != 'write')) return;
 
	if (empty($_POST)) return;
	
	// Retreiving post date
	if (!empty($_POST['pubDate']))
		$date = $_REQUEST['pubDate'];
	else 
		return;
	
	// Retreiving post time
	if (!empty($_POST['pubTime']))
		$time = $_REQUEST['pubTime'];
	else 
		return;

	$dsep = "/";
	$d = explode($dsep, $date);
	
	$tsep = ":";
	$t = explode($tsep, $time);
	
	$time = mktime ( $t[0], $t[1], $t[2], $d[1], $d[2], $d[0] );
 
	$_POST['timestamp'] = $time;
}
 
add_action('init', 'plugin_datechanger_check');
 
?>